import type { FlowOptions, VueFlowStore } from '../types'

/**
 * Composable that provides access to a store instance
 *
 * If no id is provided, the store instance is injected from context
 *
 * If no store instance is found in context, a new store instance is created and registered in storage
 *
 * @public
 * @returns a vue flow store instance
 * @param idOrOpts - id of the store instance or options to create a new store instance
 */
export declare function useVueFlow(id?: string): VueFlowStore
export declare function useVueFlow(options?: FlowOptions): VueFlowStore
